<template>
  <div>
    <div class="todo-list-app">
      <div class="task-form-container">
        <section class="header">
          <h3>New Task</h3>
          <TaskForm @submit="onSubmitTask"></TaskForm>
        </section>
        <section class="content"></section>
      </div>
      <div class="task-list-container">
          <section class="header">
              <h3>Tasks List</h3>
              <input 
                id="search-box" type="text" 
                placeholder="Search..." 
                class="form-control" 
                v-model="searchText">
              <div v-if="sortedTasks.length > 0">
                <div class="task-item-section">
                  <div class="task-item-wrap">
                  <TaskItem 
                    v-for="task in sortedTasks"
                    :key="task.id"
                    :task="{...task}"
                    @delete-task="onDeleteTask"
                    @bulkactions="selectTaskes"
                  ></TaskItem>
                  </div>
              </div>
              </div>
              <div v-else><i>No tasks</i></div>
          </section>
          <div class="bulk-actions" v-bind:class="[showBulkAction > 0 ? 'show' : 'hide']">
              <p>Bulk actions</p>
              <div>
                <button class="btn btn-primary mr-10" type="button">Done</button>
                <button class="btn btn-danger" type="button" @click="bulkRemove">Remove ({{this.selectedTasks.length}})</button>
              </div>
            </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { mapState, mapActions } from "vuex"
import { namespace, Action } from 'vuex-class'
const TaskModule = namespace('TaskModule')

import TaskForm from "./TaskForm.vue";
import TaskItem from "./TaskItem.vue";
import { Task } from '@/models/task';

@Component({
  components: {
    TaskForm,
    TaskItem,
  },
})
export default class TaskList extends Vue {
  searchText = "";
  selectedTasks: Array<string> = [];
  
  @TaskModule.State
  public tasks!: Array<Task>;
  @Action('TaskModule/checkStorage') checkStorage: any;
  @Action('TaskModule/submitTask') submitTask: any;
  @Action('TaskModule/deleteTask') deleteTask: any;
  @Action('TaskModule/bulkDelete') bulkDelete: any;
  
  get showBulkAction(): boolean{
    return this.selectedTasks.length > 0 ? true : false;
  }
  get sortedTasks(): Array<Task>{
    if(this.tasks.length == 0){
      return [];
    }
    return this.tasks.slice().sort((a: Task, b: Task) => {
        if(a.dueDate < b.dueDate){
          return -1;
        }
        if(a.dueDate > b.dueDate){
          return 1
        }
        return 0;
    }).filter((task: Task) => {
      if(task && task.title){
        return task.title.toLowerCase().includes(
          this.searchText.toLowerCase()
        )
      }
    });
  }
  
  created(){
    this.checkStorage();
  }

  onDeleteTask(id: number){
    this.deleteTask(id);
  }
  onSubmitTask(task: Task){
    this.submitTask(task);
  }
  selectTaskes(taskStatus: {id: string, isSelected: boolean}){
    if(taskStatus.isSelected){
      if(!this.selectedTasks.includes(taskStatus.id)){
        this.selectedTasks.push(taskStatus.id);
      }
    }else{
      const idx = this.selectedTasks.findIndex(item => taskStatus.id === item);
      this.selectedTasks.splice(idx, 1)
    }
  }
  bulkRemove(){
    this.bulkDelete(this.selectedTasks);
    this.selectedTasks = [];
  }
}
</script>